#
# Copyright (c) 2010 Nokia Corporation and/or its subsidiary(-ies).
# All rights reserved.
# This component and the accompanying materials are made available
# under the terms of "Eclipse Public License v1.0"
# which accompanies this distribution, and is available
# at the URL "http://www.eclipse.org/legal/epl-v10.html".
#
# Initial Contributors:
# Nokia Corporation - initial contribution.
#
# Contributors:
#
# Description:
# Various utilities for command line UI
#

''' UI utils '''

force = False

def askConfirmation(info, default_yes=False):
    ''' Return true for confirmation else false '''
    if force:
        return True
    result = ask("%s\nDo you want to continue" % info, ["y", "n"] if default_yes else None)
    yes = result == "y"
    if not yes:
        print "Operation aborted."
    return yes

def ask(question, choices=None):
    '''Asks question from user and returns given choice

    First choice in choices is default
    If force is in use default value is always returned
    '''
    choices = choices or ["n", "y"]
    choices = [c.lower() for c in choices]
    default = choices[0]
    if force:
        return "y" if "y" in choices else default
    choicesText = "/".join(choices)
    choicesText = choicesText[0].upper() + choicesText[1:]
    answer = None
    while answer not in choices + [""]:
        answer = raw_input("%s [%s]? " % (question, choicesText)).lower()
    return default if answer == "" else answer